// eztcpcfgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "eztcpcfg.h"
#include "eztcpcfgDlg.h"
#include "eztcplib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEztcpcfgDlg dialog

CEztcpcfgDlg::CEztcpcfgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEztcpcfgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEztcpcfgDlg)
	m_local_port = 0;
	m_pwd = _T("");
	m_new_pwd = _T("");
	m_comment = _T("");
	m_rcfg = FALSE;
	m_del_pwd = FALSE;
	m_ssid = _T("");
	m_ea0 = _T("");
	m_ea1 = _T("");
	m_ea2 = _T("");
	m_ea3 = _T("");
	m_ea4 = _T("");
	m_ea5 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	env_base	= (struct spe_env *)malloc(sizeof(struct spe_env) * 256);
	wenv_base	= (struct wlan_env *)malloc(sizeof(struct wlan_env) * 256);
	etc_base	= (struct etc_opt *)malloc(sizeof(struct etc_opt) * 256);
}
CEztcpcfgDlg::~CEztcpcfgDlg()
{
	free(env_base);
	free(wenv_base);
	free(etc_base);
}

void CEztcpcfgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEztcpcfgDlg)
	DDX_Control(pDX, IDC_NEW_PWD, m_ctl_new_pwd);
	DDX_Control(pDX, IDC_IPADDRESS1, m_remote_ip);
	DDX_Control(pDX, IDC_EDIT_COMMENT, m_ctl_comment);
	DDX_Control(pDX, IDC_CHECK_RCFG, m_ctl_rcfg);
	DDX_Control(pDX, IDC_LOCAL_IP, m_local_ip);
	DDX_Control(pDX, IDC_EZTCP_STATUS, m_eztcp_status);
	DDX_Control(pDX, IDC_EZTCP_LIST, m_eztcp_list);
	DDX_Text(pDX, IDC_LOCAL_PORT, m_local_port);
	DDX_Text(pDX, IDC_PWD, m_pwd);
	DDV_MaxChars(pDX, m_pwd, 8);
	DDX_Text(pDX, IDC_NEW_PWD, m_new_pwd);
	DDV_MaxChars(pDX, m_new_pwd, 8);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_comment);
	DDV_MaxChars(pDX, m_comment, 32);
	DDX_Check(pDX, IDC_CHECK_RCFG, m_rcfg);
	DDX_Text(pDX, IDC_EDIT_SSID, m_ssid);
	DDV_MaxChars(pDX, m_ssid, 32);
	DDX_Text(pDX, IDC_EDIT_EA0, m_ea0);
	DDV_MaxChars(pDX, m_ea0, 2);
	DDX_Text(pDX, IDC_EDIT_EA1, m_ea1);
	DDV_MaxChars(pDX, m_ea1, 2);
	DDX_Text(pDX, IDC_EDIT_EA2, m_ea2);
	DDV_MaxChars(pDX, m_ea2, 2);
	DDX_Text(pDX, IDC_EDIT_EA3, m_ea3);
	DDV_MaxChars(pDX, m_ea3, 2);
	DDX_Text(pDX, IDC_EDIT_EA4, m_ea4);
	DDV_MaxChars(pDX, m_ea4, 2);
	DDX_Text(pDX, IDC_EDIT_EA5, m_ea5);
	DDV_MaxChars(pDX, m_ea5, 2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEztcpcfgDlg, CDialog)
	//{{AFX_MSG_MAP(CEztcpcfgDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_PROBE, OnButtonProbe)
	ON_BN_CLICKED(IDC_BUTTON_STATUS, OnButtonStatus)
	ON_LBN_SELCHANGE(IDC_EZTCP_LIST, OnSelchangeEztcpList)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, OnButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON_LIBVERSION, OnButtonLibversion)
	ON_BN_CLICKED(IDC_BUTTON_WLAN, OnButtonWlan)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE_PWD, OnButtonRemotePwd)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE_READ, OnButtonRemoteRead)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE_STATUS, OnButtonRemoteStatus)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE_WRITE, OnButtonRemoteWrite)
	ON_BN_CLICKED(IDC_BUTTON_SET_PWD, OnButtonSetPwd)
	ON_BN_CLICKED(IDC_BUTTON_DELETE_PWD, OnButtonDeletePwd)
	ON_BN_CLICKED(IDC_BUTTON_CHANGE_PWD, OnButtonChangePwd)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE_PWD_CHANGE, OnButtonRemotePwdChange)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE_PWD_DELETE, OnButtonRemotePwdDelete)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_TCP, OnButtonCloseTcp)
	ON_BN_CLICKED(IDC_BUTTON_RESET_EZTCP, OnButtonResetEztcp)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE_CLOSE_TCP, OnButtonRemoteCloseTcp)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE_RESET_EZTCP, OnButtonRemoteResetEztcp)
	ON_BN_CLICKED(IDC_BUTTON_READ, OnButtonRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEztcpcfgDlg message handlers

BOOL CEztcpcfgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEztcpcfgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEztcpcfgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEztcpcfgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEztcpcfgDlg::OnButtonProbe() 
{
	// TODO: Add your control notification handler code here
	

	int nResult, nCount, nErr;

	//for ( int i = 0 ; i < m_eztcp_list.GetCount() ; i++ )
	m_eztcp_list.ResetContent();
	UpdateData(FALSE);

	nResult = ProbeEzTCP(env_base, wenv_base, etc_base, &nCount, &nErr);

	for (int j = 0; j < nCount; j++)
	{
		CString str_mac;
		str_mac.Format("%02X:%02X:%02X:%02X:%02X:%02X", 
			(env_base + j)->eth_addr[0],
			(env_base + j)->eth_addr[1],
			(env_base + j)->eth_addr[2],
			(env_base + j)->eth_addr[3],
			(env_base + j)->eth_addr[4],
			(env_base + j)->eth_addr[5]
			);
		m_eztcp_list.AddString(str_mac);
	}
}

void CEztcpcfgDlg::OnButtonStatus() 
{
	// TODO: Add your control notification handler code here
	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}

	int nErr;
	struct stat_env	env_stat;
	int idx = m_eztcp_list.GetCurSel();

	m_eztcp_status.SetSel(0, -1);
	m_eztcp_status.Clear();

	memset(&env_stat, 0, sizeof(stat_env));

	if ( StatusEzTCP((env_base+idx), &env_stat, &nErr) )
	{
		CString msg;

		msg.Format("Firmware Version : %s\r\n", env_stat.ver);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("Frequency : %s\r\n", env_stat.freq);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("Uptime : %d days, %02u:%02u:%02u\r\n\r\n\r\n",
			env_stat.uptime_day,
			env_stat.uptime_hour,
			env_stat.uptime_minute,
			env_stat.uptime_second
			);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("MAC Address : %02X:%02X:%02X:%02X:%02X:%02X\r\n", 
			env_stat.mac_addr[0],
			env_stat.mac_addr[1],
			env_stat.mac_addr[2],
			env_stat.mac_addr[3],
			env_stat.mac_addr[4],
			env_stat.mac_addr[5]
			);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("IP Address : %d.%d.%d.%d\r\n", 
			env_stat.ip_addr[0],
			env_stat.ip_addr[1],
			env_stat.ip_addr[2],
			env_stat.ip_addr[3]
			);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("Subnet mask : %d.%d.%d.%d\r\n", 
			env_stat.sub_mask[0],
			env_stat.sub_mask[1],
			env_stat.sub_mask[2],
			env_stat.sub_mask[3]
			);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("Gateway : %d.%d.%d.%d\r\n\r\n\r\n", 
			env_stat.gate_addr[0],
			env_stat.gate_addr[1],
			env_stat.gate_addr[2],
			env_stat.gate_addr[3]
			);
		m_eztcp_status.ReplaceSel(msg);


		msg.Format("Serial RX bytes: %lu\r\n", env_stat.sio_rx);
		m_eztcp_status.ReplaceSel(msg);
		
		msg.Format("Serial TX bytes: %lu\r\n", env_stat.sio_tx);
		m_eztcp_status.ReplaceSel(msg);
		
		msg.Format("LAN RX packets: %lu\r\n", env_stat.eth_rx);
		m_eztcp_status.ReplaceSel(msg);
		
		msg.Format("LAN TX packets: %lu\r\n", env_stat.eth_tx);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("========================================\r\n");
		m_eztcp_status.ReplaceSel(msg);
		msg.Format("%s", env_stat.text);
		m_eztcp_status.ReplaceSel(msg);
		m_eztcp_status.ReplaceSel("\r\n");
		msg.Format("========================================\r\n");
		m_eztcp_status.ReplaceSel(msg);
	}
	else
	{
		CString msg;
		msg.Format("Error : %d", nErr);
	}
}

void CEztcpcfgDlg::OnSelchangeEztcpList() 
{
	// TODO: Add your control notification handler code here
	if ( m_eztcp_list.GetCurSel() < 0 ) return;

	int idx = m_eztcp_list.GetCurSel();

	m_local_ip.SetAddress(ntohl((env_base+idx)->local_ip));
	m_local_port = (env_base+idx)->local_port;

	m_remote_ip.SetAddress(ntohl((env_base+idx)->local_ip));

	this->m_ea0.Format("%02x", (env_base+idx)->eth_addr[0]);
	this->m_ea1.Format("%02x", (env_base+idx)->eth_addr[1]);
	this->m_ea2.Format("%02x", (env_base+idx)->eth_addr[2]);
	this->m_ea3.Format("%02x", (env_base+idx)->eth_addr[3]);
	this->m_ea4.Format("%02x", (env_base+idx)->eth_addr[4]);
	this->m_ea5.Format("%02x", (env_base+idx)->eth_addr[5]);

	//========================================================
	// remote config.
	m_rcfg = FALSE;
	if((env_base+idx)->en_rcfg)
	{
		m_ctl_rcfg.EnableWindow(TRUE);
		if((env_base+idx)->rcfg)
			m_rcfg = TRUE;
	}
	else
	{
		m_ctl_rcfg.EnableWindow(FALSE);
	}
	//=========================================================

	//========================================================
	// comment.
	m_comment = "";

	//=================================================================
	// product id.
	unsigned char m_product_id = ((env_base+idx)->major >> 3) & 0x1f;
	//=================================================================

	// EZL-200F or comment option setted.
	if( m_product_id == 0x07 || (env_base+idx)->comment )
	{
		m_ctl_comment.EnableWindow(TRUE);
		
		//====================================================
		// if comment has 32 bytes. It is full size.
		unsigned char comment_buf[33];
		memset(comment_buf, 0, 33);
		memcpy(comment_buf, (etc_base+idx)->comment, 32);

		m_comment.Format("%s", comment_buf);
		//====================================================
	}
	else
	{
		m_ctl_comment.EnableWindow(FALSE);
	}
	//========================================================

	UpdateData(FALSE); 
}

void CEztcpcfgDlg::OnButtonWrite() 
{
	// TODO: Add your control notification handler code here
	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}

	int nResult, nErr;

	int idx = m_eztcp_list.GetCurSel();
	struct spe_env temp_env;
	struct etc_opt temp_etc;

	UpdateData(TRUE);

	memcpy(&temp_env, (env_base+idx), sizeof(spe_env));
	memcpy(&temp_etc,  (etc_base+idx), sizeof(etc_opt));

	m_local_ip.GetAddress(temp_env.local_ip);
	temp_env.local_ip = htonl(temp_env.local_ip);
	temp_env.local_port = m_local_port;

	temp_env.rcfg = m_rcfg;
	sprintf((char*)(temp_etc.comment), "%s", m_comment);

	//=======================================
	// password...
	if ( !m_pwd.IsEmpty() )
	{
		memset(temp_env.passwd, 0, 12);
		memcpy(temp_env.passwd, m_pwd, 8);
	}
	else
	{
		memset(temp_env.passwd, 0, 12);
	}
	//=======================================

	if ( !this->m_ssid.IsEmpty() ) 
	{
		memset((wenv_base+idx)->target_ssid, 0, 32);
		memcpy((wenv_base+idx)->target_ssid, m_ssid, m_ssid.GetLength());
	}
	else
		memset((wenv_base+idx)->target_ssid, 0, 32);

	nResult = WriteEzTCP(&temp_env, (wenv_base+idx), &temp_etc, &nErr);

	if ( nResult == 1 )
	{
		AfxMessageBox("Write Success.!!!");
		memcpy((env_base+idx), &temp_env, sizeof(spe_env));
		memcpy((etc_base+idx), &temp_etc, sizeof(etc_opt));
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Write Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}

		m_local_ip.SetAddress(ntohl((env_base+idx)->local_ip));
		m_local_port = (env_base+idx)->local_port;
	}

	m_pwd = "";
	m_new_pwd = "";
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonLibversion() 
{
	// TODO: Add your control notification handler code here
	char buf[128] ;

	if ( GetLibVerEzTCP(buf, 128) == 1 ) 
	{
		AfxMessageBox(buf);
	}
}

void CEztcpcfgDlg::OnButtonWlan() 
{
	// TODO: Add your control notification handler code here
	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}

	int nResult, nErr;

	int idx = m_eztcp_list.GetCurSel();
	struct wlan_env temp_wlan_env;
	struct spe_env  temp_env;
	struct etc_opt	temp_etc;

	AfxMessageBox("This function is only works with EZL-80/EZL-80c/EZL-90/EZL-300W Lite");

	UpdateData(TRUE);

	memcpy(&temp_env, (env_base+idx), sizeof(spe_env));
	memcpy(&temp_wlan_env, (wenv_base+idx), sizeof(wlan_env));

	memset(&temp_etc, 0, sizeof(struct etc_opt));

	//=======================================================
	// Access Point Environment value.
	// ESS-ID  : newton_ap
	// WEP     : Use.
	// WEP ID  : 1.
	// WEP KEY : Enter 0123456789 in HEX mode.
	// 
	// * For more information about Access Point, please see the ap_setting.bmp
	//
	// * The procedures.
	//
	// 1. Turn the WEP option off in the Access point.
	// 2. Clear all WLAN options on ezTCP using ezSerialConfig program.
	// 3. Set below WLAN options to ezTCP.
	// 4. The ezTCP can not link to Access Point(newton_ap).
	//    (because the AP does not support WEP.)
	// 5. Turn the WEP option on in the Access Point.
	// 6. The ezTCP can link to Access Point(newton_ap).
	//
	//	
	temp_wlan_env.cctype		= 1;	/* 0 : adhoc, 1 : infrastructure */
	temp_wlan_env.channel		= 11;	/* AP channel */
	temp_wlan_env.wep			= 1;	/* 0 : no-wep, 1 - 64 bits, 2 - 128 bits */
	temp_wlan_env.wep_id	    = 0;	/* index of WEP ID in AP. 
										  - The index start from 0(zero) in ezConfig library.
											
										*/
	temp_wlan_env.cfg_ahc		= 0;	/* see the manual for more information */
	temp_wlan_env.cfg_ifs		= 0;	/* see the manual for more information */
	
	memset(temp_wlan_env.target_ssid, 0, 32);
	sprintf((char*)temp_wlan_env.target_ssid, "%s", "newton_ap");

	memset(temp_wlan_env.new_ssid, 0, 32);	/* If you use Ad-Hoc(peer to peer) mode 
												then it should have same SSID with target_ssid*/
	
	//===================================================================================
	// Set WEP key.
	//
	memset(temp_wlan_env.key64[temp_wlan_env.wep_id], 0, sizeof(temp_wlan_env.key64[temp_wlan_env.wep_id]));
	/* wep key is 0x01, 0x23 0x45 0x67 0x89.*/
	temp_wlan_env.key64[temp_wlan_env.wep_id][0] = 0x01;
	temp_wlan_env.key64[temp_wlan_env.wep_id][1] = 0x23;
	temp_wlan_env.key64[temp_wlan_env.wep_id][2] = 0x45;
	temp_wlan_env.key64[temp_wlan_env.wep_id][3] = 0x67;
	temp_wlan_env.key64[temp_wlan_env.wep_id][4] = 0x89;
	//=======================================================
	

	//=======================================
	// pass word...
	if ( !m_pwd.IsEmpty() )
	{
		memset(temp_env.passwd, 0, 12);
		memcpy(temp_env.passwd, m_pwd, 8);
	}
	else
	{
		memset(temp_env.passwd, 0, 12);
	}
	//=======================================

	nResult = WriteEzTCP(&temp_env, &temp_wlan_env, &temp_etc, &nErr);

	if ( nResult == 1 )
	{
		AfxMessageBox("Write Success.!!!");
		memcpy((env_base+idx), &temp_env, sizeof(spe_env));
		memcpy((wenv_base+idx), &temp_wlan_env, sizeof(wlan_env));
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Write Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}

	m_pwd = "";
	m_new_pwd = "";
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonRemotePwdChange() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	char ChangePwd[12];

	int nResult, nErr;
	DWORD ip;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}

	int idx = m_eztcp_list.GetCurSel();

	//=======================================
	// previous password...
	//
	memset((env_base+idx)->passwd, 0, 12);
	memcpy((env_base+idx)->passwd, m_pwd, m_pwd.GetLength());
	
	// new password.
	memset(ChangePwd, 0, 12);
	memcpy(ChangePwd, m_new_pwd, m_new_pwd.GetLength());

	m_remote_ip.GetAddress(ip);

	nResult = RemoteChangePwdEzTCP(ip, (env_base+idx), ChangePwd, &nErr);
	//=======================================
	
	if ( nResult == 1 )
	{
		AfxMessageBox("Password Write Success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Password Write Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}


	m_pwd = "";
	m_new_pwd = "";
	UpdateData(FALSE);	
}

void CEztcpcfgDlg::OnButtonRemotePwdDelete() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	char ChangePwd[12];

	int nResult, nErr;
	DWORD ip;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}

	int idx = m_eztcp_list.GetCurSel();

	//=======================================
	// previous password...
	//
	memset((env_base+idx)->passwd, 0, 12);
	memcpy((env_base+idx)->passwd, m_pwd, m_pwd.GetLength());
	
	// new password.
	memset(ChangePwd, 0, 12);

	m_remote_ip.GetAddress(ip);

	nResult = RemoteChangePwdEzTCP(ip, (env_base+idx), ChangePwd, &nErr);
	//=======================================
	
	if ( nResult == 1 )
	{
		AfxMessageBox("Password Write Success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Password Write Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}


	m_pwd = "";
	m_new_pwd = "";
	UpdateData(FALSE);	
}

void CEztcpcfgDlg::OnButtonRemotePwd() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	char ChangePwd[12];

	int nResult, nErr;
	DWORD ip;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}
	//if ( m_new_pwd.IsEmpty() ) return;

	int idx = m_eztcp_list.GetCurSel();

	//=======================================
	// previous password...
	//
	//if ( !m_pwd.IsEmpty() )
	//{
		memset((env_base+idx)->passwd, 0, 12);
	//	memcpy((env_base+idx)->passwd, m_pwd, m_pwd.GetLength());
	//}
	//else
	//{
	//	memset((env_base+idx)->passwd, 0, 12);
	//}

	// new password.
	memset(ChangePwd, 0, 12);
	//memcpy(ChangePwd, m_new_pwd, m_new_pwd.GetLength());
	memcpy(ChangePwd, m_pwd, m_pwd.GetLength());

	m_remote_ip.GetAddress(ip);

	nResult = RemoteChangePwdEzTCP(ip, (env_base+idx), ChangePwd, &nErr);
	//=======================================
	
	if ( nResult == 1 )
	{
		AfxMessageBox("Password Write Success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Password Write Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}


	m_pwd = "";
	m_new_pwd = "";
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonRemoteRead() 
{
	// TODO: Add your control notification handler code here
	int nResult, nCount, nErr;
	DWORD ip;

	//for ( int i = 0 ; i < m_eztcp_list.GetCount() ; i++ )
	UpdateData(TRUE);
	m_remote_ip.GetAddress(ip);
	m_eztcp_list.ResetContent();
	
	nResult = RemoteReadEzTCP(ip, env_base, wenv_base, etc_base, &nCount, &nErr);

	for (int j = 0; j < nCount; j++)
	{
		CString str_mac;
		in_addr addr;

		addr.S_un.S_addr = (env_base + j)->local_ip;

		str_mac.Format("%02X:%02X:%02X:%02X:%02X:%02X(%s)", 
			(env_base + j)->eth_addr[0],
			(env_base + j)->eth_addr[1],
			(env_base + j)->eth_addr[2],
			(env_base + j)->eth_addr[3],
			(env_base + j)->eth_addr[4],
			(env_base + j)->eth_addr[5],
			inet_ntoa(addr)
			);
		m_eztcp_list.AddString(str_mac);
	}
	
	m_remote_ip.SetAddress(0);
}

void CEztcpcfgDlg::OnButtonRemoteStatus() 
{
	// TODO: Add your control notification handler code here
	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}

	int nErr;
	struct stat_env	env_stat;
	int idx = m_eztcp_list.GetCurSel();

	DWORD ip;

	m_eztcp_status.SetSel(0, -1);
	m_eztcp_status.Clear();

	memset(&env_stat, 0, sizeof(stat_env));

	m_remote_ip.GetAddress(ip);

	if ( RemoteStatusEzTCP(ip, (env_base+idx), &env_stat, &nErr) )
	{
		CString msg;

		msg.Format("Firmware Version : %s\r\n", env_stat.ver);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("Frequency : %s\r\n", env_stat.freq);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("Uptime : %d days, %02u:%02u:%02u\r\n\r\n\r\n",
			env_stat.uptime_day,
			env_stat.uptime_hour,
			env_stat.uptime_minute,
			env_stat.uptime_second
			);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("MAC Address : %02X:%02X:%02X:%02X:%02X:%02X\r\n", 
			env_stat.mac_addr[0],
			env_stat.mac_addr[1],
			env_stat.mac_addr[2],
			env_stat.mac_addr[3],
			env_stat.mac_addr[4],
			env_stat.mac_addr[5]
			);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("IP Address : %d.%d.%d.%d\r\n", 
			env_stat.ip_addr[0],
			env_stat.ip_addr[1],
			env_stat.ip_addr[2],
			env_stat.ip_addr[3]
			);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("Subnet mask : %d.%d.%d.%d\r\n", 
			env_stat.sub_mask[0],
			env_stat.sub_mask[1],
			env_stat.sub_mask[2],
			env_stat.sub_mask[3]
			);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("Gateway : %d.%d.%d.%d\r\n\r\n\r\n", 
			env_stat.gate_addr[0],
			env_stat.gate_addr[1],
			env_stat.gate_addr[2],
			env_stat.gate_addr[3]
			);
		m_eztcp_status.ReplaceSel(msg);


		msg.Format("Serial RX bytes: %lu\r\n", env_stat.sio_rx);
		m_eztcp_status.ReplaceSel(msg);
		
		msg.Format("Serial TX bytes: %lu\r\n", env_stat.sio_tx);
		m_eztcp_status.ReplaceSel(msg);
		
		msg.Format("LAN RX packets: %lu\r\n", env_stat.eth_rx);
		m_eztcp_status.ReplaceSel(msg);
		
		msg.Format("LAN TX packets: %lu\r\n", env_stat.eth_tx);
		m_eztcp_status.ReplaceSel(msg);

		msg.Format("========================================\r\n");
		m_eztcp_status.ReplaceSel(msg);
		msg.Format("%s", env_stat.text);
		m_eztcp_status.ReplaceSel(msg);
		m_eztcp_status.ReplaceSel("\r\n");
		msg.Format("========================================\r\n");
		m_eztcp_status.ReplaceSel(msg);
	}
	else
	{
		CString msg;
		msg.Format("Error : %d", nErr);
	}
}

void CEztcpcfgDlg::OnButtonRemoteWrite() 
{
	// TODO: Add your control notification handler code here
	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}

	int nResult=0, nErr=0;

	int idx = m_eztcp_list.GetCurSel();
	DWORD ip;
	struct spe_env temp_env;
	struct etc_opt temp_etc;

	UpdateData(TRUE);

	if(m_eztcp_list.GetCurSel()<0) return;

	memcpy(&temp_env, (env_base+idx), sizeof(spe_env));
	memcpy(&temp_etc,  (etc_base+idx), sizeof(etc_opt));

	m_local_ip.GetAddress(temp_env.local_ip);
	m_remote_ip.GetAddress(ip);
	temp_env.local_ip = htonl(temp_env.local_ip);
	temp_env.local_port = m_local_port;

	temp_env.rcfg = m_rcfg;
	sprintf((char*)(temp_etc.comment), "%s", m_comment);

	//=======================================
	// password...
	if ( !m_pwd.IsEmpty() )
	{
		memset(temp_env.passwd, 0, 12);
		memcpy(temp_env.passwd, m_pwd, 8);
	}
	else
	{
		memset(temp_env.passwd, 0, 12);
	}
	//=======================================

	nResult = RemoteWriteEzTCP(ip, &temp_env, (wenv_base+idx), &temp_etc, &nErr);

	if ( nResult == 1 )
	{
		AfxMessageBox("Write Success.!!!");
		memcpy((env_base+idx), &temp_env, sizeof(spe_env));
		memcpy((etc_base+idx), &temp_etc, sizeof(etc_opt));
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Write Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			switch(nErr)
			{
			case WSANOTINITIALISED:
				AfxMessageBox("Winsock not initialised");
				break;
			case WSAEACCES:
				AfxMessageBox("The requested address is a broadcast address, but the appropriate flag was not set\n");
				break;
			case WSAEINPROGRESS:
				AfxMessageBox("A blocking Windows Sockets operation is in progress\n");
				break;
			case WSAEFAULT:
				AfxMessageBox("The lpBuf argument is not in a valid part of the user address space\n");
				break;
			case WSAENOBUFS:
				AfxMessageBox("The Windows Sockets implementation reports a buffer deadlock\n");
				break;
			case WSAENOTCONN:
				AfxMessageBox("The socket is not connected\n");
				break;
			case WSAENOTSOCK:
				AfxMessageBox("The descriptor is not a socket\n");
				break;
			case WSAEOPNOTSUPP:
				AfxMessageBox("MSG_OOB was specified, but the socket is not of type SOCK_STREAM\n");
				break;
			case WSAESHUTDOWN:
				AfxMessageBox("The socket has been shut down\n");
				break;
			case WSAEWOULDBLOCK:
				AfxMessageBox("The socket is marked as nonblocking and the requested operation would block\n");
				break;
			case WSAEMSGSIZE:
				AfxMessageBox("The socket is of type SOCK_DGRAM, and the datagram is larger than the maximum supported by the Windows Sockets implementation\n");
				break;
			case WSAECONNABORTED:
				AfxMessageBox("The virtual circuit was aborted due to timeout or other failure\n");
				break;
			case WSAENETDOWN:
				AfxMessageBox("Network subsystem fail\n");
				break;
			case WSAEADDRINUSE:
				AfxMessageBox("Address already in use\n");
				break;
			case WSAEADDRNOTAVAIL:
				AfxMessageBox("Address not available\n");
				break;
			case WSAECONNREFUSED:
				AfxMessageBox("Connection refused by peer\n");
				break;
			case WSAEINVAL:
				AfxMessageBox("Invalid host name\n");
				break;
			case WSAENETUNREACH:
				AfxMessageBox("Host unreachable\n");
				break;
			case WSAECONNRESET:
				AfxMessageBox("Connection reset by peer\n");
				break;
			default:
				AfxMessageBox("Unknown network error\n");
				break;
			}
		}

		m_local_ip.SetAddress(ntohl((env_base+idx)->local_ip));
		m_local_port = (env_base+idx)->local_port;
	}

	m_pwd = "";
	m_new_pwd = "";
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonSetPwd() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	char ChangePwd[12];

	int nResult, nErr;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}
	

	int idx = m_eztcp_list.GetCurSel();

	memset((env_base+idx)->passwd, 0x00, sizeof((env_base+idx)->passwd));

	//=======================================================================
	// password
	//
	memset(ChangePwd, 0, 12);
	memcpy(ChangePwd, m_pwd, m_pwd.GetLength());
	//=======================================================================

	nResult = ChangePwdEzTCP((env_base+idx), ChangePwd, &nErr);
	
	if ( nResult == 1 )
	{
		AfxMessageBox("Password Write Success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Password Write Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}


	m_pwd = "";
	m_new_pwd = "";
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonDeletePwd() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	char ChangePwd[12];

	int nResult, nErr;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}
	

	int idx = m_eztcp_list.GetCurSel();


	//=======================================================================
	// password
	//
	memset((env_base+idx)->passwd, 0, 12);
	memcpy((env_base+idx)->passwd, m_pwd, m_pwd.GetLength());
	//=======================================================================

	//=======================================================================
	memset(ChangePwd, 0x00, 12);
	//=======================================================================

	nResult = ChangePwdEzTCP((env_base+idx), ChangePwd, &nErr);
	
	if ( nResult == 1 )
	{
		AfxMessageBox("Password Write Success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Password Write Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}


	m_pwd = "";
	m_new_pwd = "";
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonChangePwd() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	char ChangePwd[12];

	int nResult, nErr;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}
	

	int idx = m_eztcp_list.GetCurSel();


	//=======================================================================
	// password
	//
	memset((env_base+idx)->passwd, 0, 12);
	memcpy((env_base+idx)->passwd, m_pwd, m_pwd.GetLength());
	//=======================================================================

	//=======================================================================
	memset(ChangePwd, 0x00, 12);
	memcpy(ChangePwd, m_new_pwd, m_new_pwd.GetLength());
	//=======================================================================

	nResult = ChangePwdEzTCP((env_base+idx), ChangePwd, &nErr);
	
	if ( nResult == 1 )
	{
		AfxMessageBox("Password Write Success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Password Write Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}


	m_pwd = "";
	m_new_pwd = "";
	UpdateData(FALSE);
}



void CEztcpcfgDlg::OnButtonCloseTcp() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	char Pwd[12];

	int nResult, nErr;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}
	
	int idx = m_eztcp_list.GetCurSel();

	//=======================================================================
	// password
	//
	memset(Pwd, 0x00, 12);
	memcpy(Pwd, m_pwd, m_pwd.GetLength());
	//=======================================================================

	nResult = CloseTCP((env_base+idx), Pwd, &nErr);
	
	if ( nResult == 1 )
	{
		AfxMessageBox("tcp close success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("tcp close Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonResetEztcp() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	char Pwd[12];

	int nResult, nErr;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}
	
	int idx = m_eztcp_list.GetCurSel();

	//=======================================================================
	// password
	//
	memset(Pwd, 0x00, 12);
	memcpy(Pwd, m_pwd, m_pwd.GetLength());
	//=======================================================================

	nResult = ResetEzTCP((env_base+idx), Pwd, &nErr);
	
	if ( nResult == 1 )
	{
		AfxMessageBox("reset success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("reset Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonRemoteCloseTcp() 
{
	// TODO: Add your control notification handler code here
	DWORD ip;

	UpdateData(TRUE);

	char Pwd[12];

	int nResult, nErr;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}
	
	int idx = m_eztcp_list.GetCurSel();

	//=======================================================================
	// password
	//
	memset(Pwd, 0x00, 12);
	memcpy(Pwd, m_pwd, m_pwd.GetLength());
	//=======================================================================

	m_remote_ip.GetAddress(ip);

	nResult = RemoteCloseTCP(ip, (env_base+idx), Pwd, &nErr);
	
	if ( nResult == 1 )
	{
		AfxMessageBox("tcp close success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("tcp close Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonRemoteResetEztcp() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	DWORD ip;
	char Pwd[12];

	int nResult, nErr;

	if ( m_eztcp_list.GetCurSel() < 0 )
	{
		AfxMessageBox("Please select one of the ezTCPs in the ezTCP list box.");
		return;
	}
	
	int idx = m_eztcp_list.GetCurSel();

	//=======================================================================
	// password
	//
	memset(Pwd, 0x00, 12);
	memcpy(Pwd, m_pwd, m_pwd.GetLength());
	//=======================================================================

	m_remote_ip.GetAddress(ip);

	nResult = RemoteResetEzTCP(ip, (env_base+idx), Pwd, &nErr);
	
	if ( nResult == 1 )
	{
		AfxMessageBox("reset success.!!!");
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("reset Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}
	UpdateData(FALSE);
}

void CEztcpcfgDlg::OnButtonRead() 
{
	// TODO: Add your control notification handler code here
	if ( !UpdateData(TRUE) ) return;

	int res, nErr;
	_u8 mac_addr[6];

	struct spe_env	spe_env;
	struct wlan_env wlan_env;
	struct etc_opt	etc_opt;

	mac_addr[0] = (_u8)strtol(this->m_ea0, 0 , 16);
	mac_addr[1] = (_u8)strtol(this->m_ea1, 0 , 16);
	mac_addr[2] = (_u8)strtol(this->m_ea2, 0 , 16);
	mac_addr[3] = (_u8)strtol(this->m_ea3, 0 , 16);
	mac_addr[4] = (_u8)strtol(this->m_ea4, 0 , 16);
	mac_addr[5] = (_u8)strtol(this->m_ea5, 0 , 16);

	res = ReadEzTCP(mac_addr, &spe_env, &wlan_env, &etc_opt, &nErr);

	if ( res == 1 )
	{
		memcpy(this->env_base,	&spe_env,	sizeof(struct spe_env));
		memcpy(this->wenv_base, &wlan_env,	sizeof(struct wlan_env));
		memcpy(this->etc_base,	&etc_opt,	sizeof(struct etc_opt));

		this->m_eztcp_list.ResetContent();

		CString str;
		str.Format("%02x:%02x:%02x:%02x:%02x:%02x",
				this->env_base[0].eth_addr[0], 
				this->env_base[0].eth_addr[1], 
				this->env_base[0].eth_addr[2], 
				this->env_base[0].eth_addr[3], 
				this->env_base[0].eth_addr[4], 
				this->env_base[0].eth_addr[5]);
		this->m_eztcp_list.InsertString(0, str);

		this->m_eztcp_list.SetCurSel(0);
		OnSelchangeEztcpList();
	}
	else
	{
		if ( nErr == EZTCP_ERR_RES )
		{
			AfxMessageBox("Read Error...");
		}
		else if ( nErr == EZTCP_ERR_PWD )
		{
			AfxMessageBox("Password mismatch Error...");
		}
		else
		{
			AfxMessageBox("Unknown Error...");
		}
	}
}
